// Code generated by https://github.com/gagliardetto/anchor-go. DO NOT EDIT.

package khronos

import (
	"errors"
	ag_binary "github.com/gagliardetto/binary"
	ag_solanago "github.com/gagliardetto/solana-go"
	ag_format "github.com/gagliardetto/solana-go/text/format"
	ag_treeout "github.com/gagliardetto/treeout"
)

// InitializeVault is the `initializeVault` instruction.
type InitializeVault struct {
	Period          *uint8
	Percentil       *uint8
	Amount          *uint64
	DepositBump     *uint8
	DestinationBump *uint8

	// [0] = [WRITE] depositAccount
	//
	// [1] = [WRITE] destinationAccount
	//
	// [2] = [WRITE, SIGNER] vault
	//
	// [3] = [WRITE, SIGNER] authority
	//
	// [4] = [] depositMint
	//
	// [5] = [] destinationMint
	//
	// [6] = [WRITE] ownerDepositTokenAccount
	//
	// [7] = [] systemProgram
	//
	// [8] = [] tokenProgram
	//
	// [9] = [] rent
	ag_solanago.AccountMetaSlice `bin:"-"`
}

// NewInitializeVaultInstructionBuilder creates a new `InitializeVault` instruction builder.
func NewInitializeVaultInstructionBuilder() *InitializeVault {
	nd := &InitializeVault{
		AccountMetaSlice: make(ag_solanago.AccountMetaSlice, 10),
	}
	return nd
}

// SetPeriod sets the "period" parameter.
func (inst *InitializeVault) SetPeriod(period uint8) *InitializeVault {
	inst.Period = &period
	return inst
}

// SetPercentil sets the "percentil" parameter.
func (inst *InitializeVault) SetPercentil(percentil uint8) *InitializeVault {
	inst.Percentil = &percentil
	return inst
}

// SetAmount sets the "amount" parameter.
func (inst *InitializeVault) SetAmount(amount uint64) *InitializeVault {
	inst.Amount = &amount
	return inst
}

// SetDepositBump sets the "depositBump" parameter.
func (inst *InitializeVault) SetDepositBump(depositBump uint8) *InitializeVault {
	inst.DepositBump = &depositBump
	return inst
}

// SetDestinationBump sets the "destinationBump" parameter.
func (inst *InitializeVault) SetDestinationBump(destinationBump uint8) *InitializeVault {
	inst.DestinationBump = &destinationBump
	return inst
}

// SetDepositAccountAccount sets the "depositAccount" account.
func (inst *InitializeVault) SetDepositAccountAccount(depositAccount ag_solanago.PublicKey) *InitializeVault {
	inst.AccountMetaSlice[0] = ag_solanago.Meta(depositAccount).WRITE()
	return inst
}

// GetDepositAccountAccount gets the "depositAccount" account.
func (inst *InitializeVault) GetDepositAccountAccount() *ag_solanago.AccountMeta {
	return inst.AccountMetaSlice.Get(0)
}

// SetDestinationAccountAccount sets the "destinationAccount" account.
func (inst *InitializeVault) SetDestinationAccountAccount(destinationAccount ag_solanago.PublicKey) *InitializeVault {
	inst.AccountMetaSlice[1] = ag_solanago.Meta(destinationAccount).WRITE()
	return inst
}

// GetDestinationAccountAccount gets the "destinationAccount" account.
func (inst *InitializeVault) GetDestinationAccountAccount() *ag_solanago.AccountMeta {
	return inst.AccountMetaSlice.Get(1)
}

// SetVaultAccount sets the "vault" account.
func (inst *InitializeVault) SetVaultAccount(vault ag_solanago.PublicKey) *InitializeVault {
	inst.AccountMetaSlice[2] = ag_solanago.Meta(vault).WRITE().SIGNER()
	return inst
}

// GetVaultAccount gets the "vault" account.
func (inst *InitializeVault) GetVaultAccount() *ag_solanago.AccountMeta {
	return inst.AccountMetaSlice.Get(2)
}

// SetAuthorityAccount sets the "authority" account.
func (inst *InitializeVault) SetAuthorityAccount(authority ag_solanago.PublicKey) *InitializeVault {
	inst.AccountMetaSlice[3] = ag_solanago.Meta(authority).WRITE().SIGNER()
	return inst
}

// GetAuthorityAccount gets the "authority" account.
func (inst *InitializeVault) GetAuthorityAccount() *ag_solanago.AccountMeta {
	return inst.AccountMetaSlice.Get(3)
}

// SetDepositMintAccount sets the "depositMint" account.
func (inst *InitializeVault) SetDepositMintAccount(depositMint ag_solanago.PublicKey) *InitializeVault {
	inst.AccountMetaSlice[4] = ag_solanago.Meta(depositMint)
	return inst
}

// GetDepositMintAccount gets the "depositMint" account.
func (inst *InitializeVault) GetDepositMintAccount() *ag_solanago.AccountMeta {
	return inst.AccountMetaSlice.Get(4)
}

// SetDestinationMintAccount sets the "destinationMint" account.
func (inst *InitializeVault) SetDestinationMintAccount(destinationMint ag_solanago.PublicKey) *InitializeVault {
	inst.AccountMetaSlice[5] = ag_solanago.Meta(destinationMint)
	return inst
}

// GetDestinationMintAccount gets the "destinationMint" account.
func (inst *InitializeVault) GetDestinationMintAccount() *ag_solanago.AccountMeta {
	return inst.AccountMetaSlice.Get(5)
}

// SetOwnerDepositTokenAccountAccount sets the "ownerDepositTokenAccount" account.
func (inst *InitializeVault) SetOwnerDepositTokenAccountAccount(ownerDepositTokenAccount ag_solanago.PublicKey) *InitializeVault {
	inst.AccountMetaSlice[6] = ag_solanago.Meta(ownerDepositTokenAccount).WRITE()
	return inst
}

// GetOwnerDepositTokenAccountAccount gets the "ownerDepositTokenAccount" account.
func (inst *InitializeVault) GetOwnerDepositTokenAccountAccount() *ag_solanago.AccountMeta {
	return inst.AccountMetaSlice.Get(6)
}

// SetSystemProgramAccount sets the "systemProgram" account.
func (inst *InitializeVault) SetSystemProgramAccount(systemProgram ag_solanago.PublicKey) *InitializeVault {
	inst.AccountMetaSlice[7] = ag_solanago.Meta(systemProgram)
	return inst
}

// GetSystemProgramAccount gets the "systemProgram" account.
func (inst *InitializeVault) GetSystemProgramAccount() *ag_solanago.AccountMeta {
	return inst.AccountMetaSlice.Get(7)
}

// SetTokenProgramAccount sets the "tokenProgram" account.
func (inst *InitializeVault) SetTokenProgramAccount(tokenProgram ag_solanago.PublicKey) *InitializeVault {
	inst.AccountMetaSlice[8] = ag_solanago.Meta(tokenProgram)
	return inst
}

// GetTokenProgramAccount gets the "tokenProgram" account.
func (inst *InitializeVault) GetTokenProgramAccount() *ag_solanago.AccountMeta {
	return inst.AccountMetaSlice.Get(8)
}

// SetRentAccount sets the "rent" account.
func (inst *InitializeVault) SetRentAccount(rent ag_solanago.PublicKey) *InitializeVault {
	inst.AccountMetaSlice[9] = ag_solanago.Meta(rent)
	return inst
}

// GetRentAccount gets the "rent" account.
func (inst *InitializeVault) GetRentAccount() *ag_solanago.AccountMeta {
	return inst.AccountMetaSlice.Get(9)
}

func (inst InitializeVault) Build() *Instruction {
	return &Instruction{BaseVariant: ag_binary.BaseVariant{
		Impl:   inst,
		TypeID: Instruction_InitializeVault,
	}}
}

// ValidateAndBuild validates the instruction parameters and accounts;
// if there is a validation error, it returns the error.
// Otherwise, it builds and returns the instruction.
func (inst InitializeVault) ValidateAndBuild() (*Instruction, error) {
	if err := inst.Validate(); err != nil {
		return nil, err
	}
	return inst.Build(), nil
}

func (inst *InitializeVault) Validate() error {
	// Check whether all (required) parameters are set:
	{
		if inst.Period == nil {
			return errors.New("Period parameter is not set")
		}
		if inst.Percentil == nil {
			return errors.New("Percentil parameter is not set")
		}
		if inst.Amount == nil {
			return errors.New("Amount parameter is not set")
		}
		if inst.DepositBump == nil {
			return errors.New("DepositBump parameter is not set")
		}
		if inst.DestinationBump == nil {
			return errors.New("DestinationBump parameter is not set")
		}
	}

	// Check whether all (required) accounts are set:
	{
		if inst.AccountMetaSlice[0] == nil {
			return errors.New("accounts.DepositAccount is not set")
		}
		if inst.AccountMetaSlice[1] == nil {
			return errors.New("accounts.DestinationAccount is not set")
		}
		if inst.AccountMetaSlice[2] == nil {
			return errors.New("accounts.Vault is not set")
		}
		if inst.AccountMetaSlice[3] == nil {
			return errors.New("accounts.Authority is not set")
		}
		if inst.AccountMetaSlice[4] == nil {
			return errors.New("accounts.DepositMint is not set")
		}
		if inst.AccountMetaSlice[5] == nil {
			return errors.New("accounts.DestinationMint is not set")
		}
		if inst.AccountMetaSlice[6] == nil {
			return errors.New("accounts.OwnerDepositTokenAccount is not set")
		}
		if inst.AccountMetaSlice[7] == nil {
			return errors.New("accounts.SystemProgram is not set")
		}
		if inst.AccountMetaSlice[8] == nil {
			return errors.New("accounts.TokenProgram is not set")
		}
		if inst.AccountMetaSlice[9] == nil {
			return errors.New("accounts.Rent is not set")
		}
	}
	return nil
}

func (inst *InitializeVault) EncodeToTree(parent ag_treeout.Branches) {
	parent.Child(ag_format.Program(ProgramName, ProgramID)).
		//
		ParentFunc(func(programBranch ag_treeout.Branches) {
			programBranch.Child(ag_format.Instruction("InitializeVault")).
				//
				ParentFunc(func(instructionBranch ag_treeout.Branches) {

					// Parameters of the instruction:
					instructionBranch.Child("Params[len=5]").ParentFunc(func(paramsBranch ag_treeout.Branches) {
						paramsBranch.Child(ag_format.Param("         Period", *inst.Period))
						paramsBranch.Child(ag_format.Param("      Percentil", *inst.Percentil))
						paramsBranch.Child(ag_format.Param("         Amount", *inst.Amount))
						paramsBranch.Child(ag_format.Param("    DepositBump", *inst.DepositBump))
						paramsBranch.Child(ag_format.Param("DestinationBump", *inst.DestinationBump))
					})

					// Accounts of the instruction:
					instructionBranch.Child("Accounts[len=10]").ParentFunc(func(accountsBranch ag_treeout.Branches) {
						accountsBranch.Child(ag_format.Meta("          deposit", inst.AccountMetaSlice.Get(0)))
						accountsBranch.Child(ag_format.Meta("      destination", inst.AccountMetaSlice.Get(1)))
						accountsBranch.Child(ag_format.Meta("            vault", inst.AccountMetaSlice.Get(2)))
						accountsBranch.Child(ag_format.Meta("        authority", inst.AccountMetaSlice.Get(3)))
						accountsBranch.Child(ag_format.Meta("      depositMint", inst.AccountMetaSlice.Get(4)))
						accountsBranch.Child(ag_format.Meta("  destinationMint", inst.AccountMetaSlice.Get(5)))
						accountsBranch.Child(ag_format.Meta("ownerDepositToken", inst.AccountMetaSlice.Get(6)))
						accountsBranch.Child(ag_format.Meta("    systemProgram", inst.AccountMetaSlice.Get(7)))
						accountsBranch.Child(ag_format.Meta("     tokenProgram", inst.AccountMetaSlice.Get(8)))
						accountsBranch.Child(ag_format.Meta("             rent", inst.AccountMetaSlice.Get(9)))
					})
				})
		})
}

func (obj InitializeVault) MarshalWithEncoder(encoder *ag_binary.Encoder) (err error) {
	// Serialize `Period` param:
	err = encoder.Encode(obj.Period)
	if err != nil {
		return err
	}
	// Serialize `Percentil` param:
	err = encoder.Encode(obj.Percentil)
	if err != nil {
		return err
	}
	// Serialize `Amount` param:
	err = encoder.Encode(obj.Amount)
	if err != nil {
		return err
	}
	// Serialize `DepositBump` param:
	err = encoder.Encode(obj.DepositBump)
	if err != nil {
		return err
	}
	// Serialize `DestinationBump` param:
	err = encoder.Encode(obj.DestinationBump)
	if err != nil {
		return err
	}
	return nil
}
func (obj *InitializeVault) UnmarshalWithDecoder(decoder *ag_binary.Decoder) (err error) {
	// Deserialize `Period`:
	err = decoder.Decode(&obj.Period)
	if err != nil {
		return err
	}
	// Deserialize `Percentil`:
	err = decoder.Decode(&obj.Percentil)
	if err != nil {
		return err
	}
	// Deserialize `Amount`:
	err = decoder.Decode(&obj.Amount)
	if err != nil {
		return err
	}
	// Deserialize `DepositBump`:
	err = decoder.Decode(&obj.DepositBump)
	if err != nil {
		return err
	}
	// Deserialize `DestinationBump`:
	err = decoder.Decode(&obj.DestinationBump)
	if err != nil {
		return err
	}
	return nil
}

// NewInitializeVaultInstruction declares a new InitializeVault instruction with the provided parameters and accounts.
func NewInitializeVaultInstruction(
	// Parameters:
	period uint8,
	percentil uint8,
	amount uint64,
	depositBump uint8,
	destinationBump uint8,
	// Accounts:
	depositAccount ag_solanago.PublicKey,
	destinationAccount ag_solanago.PublicKey,
	vault ag_solanago.PublicKey,
	authority ag_solanago.PublicKey,
	depositMint ag_solanago.PublicKey,
	destinationMint ag_solanago.PublicKey,
	ownerDepositTokenAccount ag_solanago.PublicKey,
	systemProgram ag_solanago.PublicKey,
	tokenProgram ag_solanago.PublicKey,
	rent ag_solanago.PublicKey) *InitializeVault {
	return NewInitializeVaultInstructionBuilder().
		SetPeriod(period).
		SetPercentil(percentil).
		SetAmount(amount).
		SetDepositBump(depositBump).
		SetDestinationBump(destinationBump).
		SetDepositAccountAccount(depositAccount).
		SetDestinationAccountAccount(destinationAccount).
		SetVaultAccount(vault).
		SetAuthorityAccount(authority).
		SetDepositMintAccount(depositMint).
		SetDestinationMintAccount(destinationMint).
		SetOwnerDepositTokenAccountAccount(ownerDepositTokenAccount).
		SetSystemProgramAccount(systemProgram).
		SetTokenProgramAccount(tokenProgram).
		SetRentAccount(rent)
}
